<?php
/**
 * @version     1.0.0
 * @package     plg_arkeditor
 * @copyright   Copyright (C) 2017. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      WebxSolution Ltd - http://www.arkextensions.com
 */

defined( '_JEXEC' ) or die;

JHTML::_( 'jquery.framework' );

JText::script( 'PLG_TEMPLATE-XTD_ENABLED_MSG' );
JText::script( 'PLG_TEMPLATE-XTD_DISABLED_MSG' );
JText::script( 'PLG_TEMPLATE-XTD_SAVED_MSG' );
JText::script( 'PLG_TEMPLATE-XTD_SAVING_MSG' );
JText::script( 'PLG_TEMPLATE-XTD_SAVEPARTIAL_MSG' );
?>
<script>
	jQuery( document ).ready( function( $ )
	{
		var $menu = $( '[ark-toolbar] [ark-toolbar-item="arkeditor"]' );

		// Disable inline editor
		if( window.CKEDITOR && CKEDITOR.disableInlineEventHandlers )
		{
			$menu.hide();

			return;
		}//end if

		$menu.on( 'click', '[ark-toolbar-action="save"]', function( ev )
		{
			arkUIkit.notification({ message : '<i ark-icon="clock" class="ark-margin-small-right"></i>' + Joomla.JText._( 'PLG_TEMPLATE-XTD_SAVING_MSG' ) });

			jSaveAllInstances();
		});

		$menu.on( 'click', '[ark-toolbar-action="enable"], [ark-toolbar-action="disable"]', function( ev )
		{
			var message, $sibling = null;

			switch( $( this ).attr( 'ark-toolbar-action' ) )
			{
				case 'enable' :
					message		= Joomla.JText._( 'PLG_TEMPLATE-XTD_ENABLED_MSG' );
					$sibling 	= 'disable';
					break;
				
				case 'disable' :
					message		= Joomla.JText._( 'PLG_TEMPLATE-XTD_DISABLED_MSG' );
					$sibling 	= 'enable';
					break;
			}//end switch

			// Activate
			toggleEditor( true );

			// Toggle controls
			$( this ).attr( 'hidden', '' );
			$menu.find( '[ark-toolbar-action="' + $sibling + '"]' ).removeAttr( 'hidden' );

			// Toggle menu status
			$menu.find( '[ark-toolbar-item-link]' ).toggleClass( 'ark-text-success' );

			// User notification
			arkUIkit.notification({ message : '<i ark-icon="check" class="ark-margin-small-right"></i>' + message });
		});

		if( window.CKEDITOR )
        {
            CKEDITOR.on( 'autoDisableInline', function()
            {
                $menu.find( '[ark-toolbar-item-link]' ).removeClass( 'ark-text-success' );
                $menu.find( '[ark-toolbar-action="enable"]' ).removeAttr( 'hidden' );
                $menu.find( '[ark-toolbar-action="disable"]' ).attr( 'hidden', '' );

                // @note The below actual onload disabling is handled by the old inlinelayouts/sidebar.php
                // toggleEditor();
            });
        }

		// Enable/disable inline editing
		function toggleEditor( toggleNativeLinks )
		{
			jDisableOrEnableAllInstances( toggleNativeLinks );

			if (CKEDITOR.enableManualInline) {
				if (window.addEventListener)
					document.body.addEventListener('click', CKEDITOR.inlineClick, false);
				else if (window.attachEvent)
					document.body.attachEvent('onclick', CKEDITOR.inlineClick);

				url = 'index.php?option=com_ajax&plugin=inlinemodestatelistener&format=json&state=0';
				jQuery.get(url,function( response ){});		
			}
			else {
				if (window.removeEventListener)
					document.body.removeEventListener('click', CKEDITOR.inlineClick, false);
				else if (window.detachEvent)
					document.body.detachEvent('onclick', CKEDITOR.inlineClick);

				url = 'index.php?option=com_ajax&plugin=inlinemodestatelistener&format=json&state=1';
				jQuery.get(url,function( response ){});	
			};
		}

		// Remove old message & HTML
		$( 'div.ark.inline.alert' ).remove();
		$( '#ark-navbar' ).remove();
	});
</script>
<?php /* Hide old sidebar in CSS to prevent jump before JS removal */ ?>
<style>
	#ark-navbar { display : none; }
</style>