<?php
/*------------------------------------------------------------------------
# Copyright (C) 2016-2018 WebxSolution Ltd. All Rights Reserved.
# @license - GPLv2.0
# Author: WebxSolution Ltd
# Websites:  http://www.webxsolution.com
# Terms of Use: An extension that is derived from the JoomlaCK editor will only be allowed under the following conditions: http://joomlackeditor.com/terms-of-use
# ------------------------------------------------------------------------*/ 

defined('_JEXEC') or die;

/**
 *Ark inline content  System Plugin
 *
 * @package     Joomla.Plugin
 * @subpackage  System.arkeditoruser
 */
 
 
class PlgSystemArKEditorUser extends JPlugin
{

	 public function onAfterRoute()
     {

		$app = JFactory::getApplication();

 		if(!file_exists(JPATH_PLUGINS.'/editors/arkeditor')) {
			return;
		}

		jimport('joomla.plugin.helper');

        if(!JPluginHelper::isEnabled('editors','arkeditor'))
           return;
		
		$component = JComponentHelper::getParams('com_arkeditor');
		$this->params = $component;
		
		//check editor parameters
		$useUserFolder 	=  $this->params->get('enable_userfolders',1);
		$userFolderType =  $this->params->get('userfoldertype','username');
				
		if(!$useUserFolder)
			return;
		
		//Get user
		$user = JFactory::getUser();
		//Joomla does not have a function to determine if a user belonging
		//to a group is in this set.  As a result we have to do the work
		//ourselves.
		$groups			= $user->getAuthorisedGroups();
		$restirectTo 	= $this->params->get( 'displayFoldersTo', false );

        $groups = array_values($groups);
 
		//check to see if user is root user if so skip

		if($user->authorise('core.admin')) //Fix for Joomla 3.6+
			return;
		
		//check to see if user belongs to a usergroup that allows full access
		
		if( $groups && $restirectTo )
		{
			for( $n=0, $i=count($groups); $n<$i; $n++ )
			{
                
                if( in_array( $groups[$n], $restirectTo ) )
				{
					//Seems this user is able to view all folders.
					return;
				}//end if
			}//end for loop
		}//end if

		//Get user id
		if($userFolderType == 'username')
		{
			$id =  $user->username;
		}	
		else
		{ 	
			$id  = $user->id;	
		}
		//Now set media paths
		//Get current value set in DB
		$imagePath = $this->params->get('imagePath','images') . '/' . $id;
		
		
		jimport('joomla.filesystem.folder');
		
		if(!JFolder::exists($imagePath))
		{
			$imagePath = $this->params->get('imagePath','images') . '/users/' . $id;
		}
			
		//Check to see if the $imagePath Exists. If not create it.
		if( !JFolder::Exists( JPATH_ROOT.'/'.$imagePath ) )
		{
			if( !JFolder::create( JPATH_ROOT.'/'.$imagePath ) )
			{
				throw new Exception( 'Failed to create user folder' );
			}//end if
		}//end if
	
		$component->set('imagePath',$imagePath);
		
	
		//Now set media paths
		//Get current value set in DB
		$filePath = $this->params->get('filePath','files')  . '/' . $id;
		
		if(!JFolder::exists($filePath))
		{
			$filePath = $this->params->get('filePath','files') . '/users/' . $id;
		}
		
		//Check to see if the $filePath Exists. If not create it.
		if( !JFolder::Exists( JPATH_ROOT.'/'.$filePath ) )
		{
			if( !JFolder::create( JPATH_ROOT.'/'.$filePath ) )
			{
				throw new Exception( 'Failed to create files folder' );
			}//end if
		}//end if

		$component->set('filePath',$filePath);
     }
}