<?php
/*------------------------------------------------------------------------
# Copyright (C) 2014-2015 WebxSolution Ltd. All Rights Reserved.
# @license - GPLv2.0
# Author: WebxSolution Ltd
# Websites:  http://www.webxsolution.com
# Terms of Use: An extension that is derived from the JoomlaCK editor will only be allowed under the following conditions: http://joomlackeditor.com/terms-of-use
# ------------------------------------------------------------------------*/ 

defined('_JEXEC') or die;

/**
 *Ark  Editor Plugin
 *
 * @package     Joomla.Plugin
 * @subpackage  ArkEditor.UploadWidget
 */
class PlgArkEditorUploadWidget extends JPlugin
{
	public function onInstanceBeforeCreated(&$params) 
    {
	   if(version_compare(JVERSION, '4.0', 'ge' ))
	   {

		return " editor.once( 'configLoaded', function() 
				{
					if(!CKEDITOR.loadedExtUploadwidget && CKEDITOR.plugins.registered.uploadwidget) // already loaded by core CKEDITOR JS file
					{
						CKEDITOR.plugins.registered.uploadwidget = {};
						CKEDITOR.loadedExtUploadwidget = true; 
					}	
				
				});
				
								
				editor.once( 'langLoaded', function(ev) 
				{
					if(CKEDITOR.lang[this.langCode] && CKEDITOR.lang[this.langCode].uploadwidget) //if language exists for uploadwidget plugions
						delete CKEDITOR.lang[this.langCode].uploadwidget;
				});
				
				
				editor.on( 'fileUploadRequest', function( evt ) 
				{
					const fileLoader = evt.data.fileLoader,
						xhr = fileLoader.xhr,
						configXhrHeaders = editor.config.fileTools_requestHeaders,
				        jsonData = {};
	
					jsonData.name = fileLoader.fileName;
					jsonData.content = fileLoader.data.replace(/data:.*?;base64,/,'');
					xhr.open( 'POST', fileLoader.uploadUrl, true );
					
					jsonData[Joomla.getOptions('csrf.token')] = 1;
					
					jsonData.ckCsrfToken = CKEDITOR.tools.getCsrfToken();

					if ( configXhrHeaders ) {
						for (const header in configXhrHeaders ) {
							xhr.setRequestHeader( header, configXhrHeaders[ header ] );
						}
					}
					
					xhr.setRequestHeader('Content-Type','application/json')
					
					const data = JSON.stringify(jsonData);
					
				    xhr.send(data);
					
					// Prevented default behavior.
					evt.stop();
				}, null, null, 4 );
			";    
       }   		   
		
	   return "	editor.once( 'configLoaded', function() 
				{
					if(!CKEDITOR.loadedExtUploadwidget && CKEDITOR.plugins.registered.uploadwidget) // already loaded by core CKEDITOR JS file
					{
						CKEDITOR.plugins.registered.uploadwidget = {};
						CKEDITOR.loadedExtUploadwidget = true; 
					}	
				
				});
				
								
				editor.once( 'langLoaded', function(ev) 
				{
					if(CKEDITOR.lang[this.langCode] && CKEDITOR.lang[this.langCode].uploadwidget) //if language exists for uploadwidget plugions
						delete CKEDITOR.lang[this.langCode].uploadwidget;
				});
				
				
				editor.on( 'fileUploadRequest', function( evt ) 
				{
					var fileLoader = evt.data.fileLoader,
						formData = new FormData();

					formData.append( 'Filedata', fileLoader.file, fileLoader.fileName );
					formData.append(Joomla.getOptions('csrf.token'),1);
					fileLoader.xhr.send( formData );
					
					// Prevented default behavior.
					evt.stop();
				}, null, null, 10 );
			";    
    }
		
	public function onInstanceLoaded(&$params) {}
}
